










































































































typedef
struct _MKL_Complex8 {
    float real;
    float imag;
} MKL_Complex8;




typedef
struct _MKL_Complex16 {
    double real;
    double imag;
} MKL_Complex16;



typedef
struct {
    int    MajorVersion;
    int    MinorVersion;
    int    UpdateVersion;
    char * ProductStatus;
    char * Build;
    char * Processor;
    char * Platform;
} MKLVersion;



    
    




















    


    













































































typedef struct _DefVmlErrorContext
{
    int     iCode;
    int     iIndex;
    double  dbA1;
    double  dbA2;
    double  dbR1;
    double  dbR2;
    char    cFuncName[64];
    int     iFuncNameLen;
    double  dbA1Im;
    double  dbA2Im;
    double  dbR1Im;
    double  dbR2Im;
} DefVmlErrorContext;




typedef int (*VMLErrorCallBack) (DefVmlErrorContext* pdefVmlErrorContext);






















   
      


         
      
   






















extern void  VSABS (const int *n, const float a[], float r[]);
extern void  VDABS (const int *n, const double a[], double r[]);
extern void  vsabs (const int *n, const float a[], float r[]);
extern void  vdabs (const int *n, const double a[], double r[]);
extern void  vsAbs (const int n, const float a[], float r[]);
extern void  vdAbs (const int n, const double a[], double r[]);

extern void  VMSABS (const int *n, const float a[], float r[], long long int *mode);
extern void  VMDABS (const int *n, const double a[], double r[], long long int *mode);
extern void  vmsabs (const int *n, const float a[], float r[], long long int *mode);
extern void  vmdabs (const int *n, const double a[], double r[], long long int *mode);
extern void  vmsAbs (const int n, const float a[], float r[], long long int mode);
extern void  vmdAbs (const int n, const double a[], double r[], long long int mode);


extern void  VCABS (const int *n, const MKL_Complex8 a[], float r[]);
extern void  VZABS (const int *n, const MKL_Complex16 a[], double r[]);
extern void  vcabs (const int *n, const MKL_Complex8 a[], float r[]);
extern void  vzabs (const int *n, const MKL_Complex16 a[], double r[]);
extern void  vcAbs (const int n, const MKL_Complex8 a[], float r[]);
extern void  vzAbs (const int n, const MKL_Complex16 a[], double r[]);

extern void  VMCABS (const int *n, const MKL_Complex8 a[], float r[], long long int *mode);
extern void  VMZABS (const int *n, const MKL_Complex16 a[], double r[], long long int *mode);
extern void  vmcabs (const int *n, const MKL_Complex8 a[], float r[], long long int *mode);
extern void  vmzabs (const int *n, const MKL_Complex16 a[], double r[], long long int *mode);
extern void  vmcAbs (const int n, const MKL_Complex8 a[], float r[], long long int mode);
extern void  vmzAbs (const int n, const MKL_Complex16 a[], double r[], long long int mode);


extern void  VCARG (const int *n, const MKL_Complex8 a[], float r[]);
extern void  VZARG (const int *n, const MKL_Complex16 a[], double r[]);
extern void  vcarg (const int *n, const MKL_Complex8 a[], float r[]);
extern void  vzarg (const int *n, const MKL_Complex16 a[], double r[]);
extern void  vcArg (const int n, const MKL_Complex8 a[], float r[]);
extern void  vzArg (const int n, const MKL_Complex16 a[], double r[]);

extern void  VMCARG (const int *n, const MKL_Complex8 a[], float r[], long long int *mode);
extern void  VMZARG (const int *n, const MKL_Complex16 a[], double r[], long long int *mode);
extern void  vmcarg (const int *n, const MKL_Complex8 a[], float r[], long long int *mode);
extern void  vmzarg (const int *n, const MKL_Complex16 a[], double r[], long long int *mode);
extern void  vmcArg (const int n, const MKL_Complex8 a[], float r[], long long int mode);
extern void  vmzArg (const int n, const MKL_Complex16 a[], double r[], long long int mode);


extern void  VSADD (const int *n, const float a[], const float b[], float r[]);
extern void  VDADD (const int *n, const double a[], const double b[], double r[]);
extern void  vsadd (const int *n, const float a[], const float b[], float r[]);
extern void  vdadd (const int *n, const double a[], const double b[], double r[]);
extern void  vsAdd (const int n, const float a[], const float b[], float r[]);
extern void  vdAdd (const int n, const double a[], const double b[], double r[]);

extern void  VMSADD (const int *n, const float a[], const float b[], float r[], long long int *mode);
extern void  VMDADD (const int *n, const double a[], const double b[], double r[], long long int *mode);
extern void  vmsadd (const int *n, const float a[], const float b[], float r[], long long int *mode);
extern void  vmdadd (const int *n, const double a[], const double b[], double r[], long long int *mode);
extern void  vmsAdd (const int n, const float a[], const float b[], float r[], long long int mode);
extern void  vmdAdd (const int n, const double a[], const double b[], double r[], long long int mode);


extern void  VCADD (const int *n, const MKL_Complex8 a[], const MKL_Complex8 b[], MKL_Complex8 r[]);
extern void  VZADD (const int *n, const MKL_Complex16 a[], const MKL_Complex16 b[], MKL_Complex16 r[]);
extern void  vcadd (const int *n, const MKL_Complex8 a[], const MKL_Complex8 b[], MKL_Complex8 r[]);
extern void  vzadd (const int *n, const MKL_Complex16 a[], const MKL_Complex16 b[], MKL_Complex16 r[]);
extern void  vcAdd (const int n, const MKL_Complex8 a[], const MKL_Complex8 b[], MKL_Complex8 r[]);
extern void  vzAdd (const int n, const MKL_Complex16 a[], const MKL_Complex16 b[], MKL_Complex16 r[]);

extern void  VMCADD (const int *n, const MKL_Complex8 a[], const MKL_Complex8 b[], MKL_Complex8 r[], long long int *mode);
extern void  VMZADD (const int *n, const MKL_Complex16 a[], const MKL_Complex16 b[], MKL_Complex16 r[], long long int *mode);
extern void  vmcadd (const int *n, const MKL_Complex8 a[], const MKL_Complex8 b[], MKL_Complex8 r[], long long int *mode);
extern void  vmzadd (const int *n, const MKL_Complex16 a[], const MKL_Complex16 b[], MKL_Complex16 r[], long long int *mode);
extern void  vmcAdd (const int n, const MKL_Complex8 a[], const MKL_Complex8 b[], MKL_Complex8 r[], long long int mode);
extern void  vmzAdd (const int n, const MKL_Complex16 a[], const MKL_Complex16 b[], MKL_Complex16 r[], long long int mode);


extern void  VSSUB (const int *n, const float a[], const float b[], float r[]);
extern void  VDSUB (const int *n, const double a[], const double b[], double r[]);
extern void  vssub (const int *n, const float a[], const float b[], float r[]);
extern void  vdsub (const int *n, const double a[], const double b[], double r[]);
extern void  vsSub (const int n, const float a[], const float b[], float r[]);
extern void  vdSub (const int n, const double a[], const double b[], double r[]);

extern void  VMSSUB (const int *n, const float a[], const float b[], float r[], long long int *mode);
extern void  VMDSUB (const int *n, const double a[], const double b[], double r[], long long int *mode);
extern void  vmssub (const int *n, const float a[], const float b[], float r[], long long int *mode);
extern void  vmdsub (const int *n, const double a[], const double b[], double r[], long long int *mode);
extern void  vmsSub (const int n, const float a[], const float b[], float r[], long long int mode);
extern void  vmdSub (const int n, const double a[], const double b[], double r[], long long int mode);


extern void  VCSUB (const int *n, const MKL_Complex8 a[], const MKL_Complex8 b[], MKL_Complex8 r[]);
extern void  VZSUB (const int *n, const MKL_Complex16 a[], const MKL_Complex16 b[], MKL_Complex16 r[]);
extern void  vcsub (const int *n, const MKL_Complex8 a[], const MKL_Complex8 b[], MKL_Complex8 r[]);
extern void  vzsub (const int *n, const MKL_Complex16 a[], const MKL_Complex16 b[], MKL_Complex16 r[]);
extern void  vcSub (const int n, const MKL_Complex8 a[], const MKL_Complex8 b[], MKL_Complex8 r[]);
extern void  vzSub (const int n, const MKL_Complex16 a[], const MKL_Complex16 b[], MKL_Complex16 r[]);

extern void  VMCSUB (const int *n, const MKL_Complex8 a[], const MKL_Complex8 b[], MKL_Complex8 r[], long long int *mode);
extern void  VMZSUB (const int *n, const MKL_Complex16 a[], const MKL_Complex16 b[], MKL_Complex16 r[], long long int *mode);
extern void  vmcsub (const int *n, const MKL_Complex8 a[], const MKL_Complex8 b[], MKL_Complex8 r[], long long int *mode);
extern void  vmzsub (const int *n, const MKL_Complex16 a[], const MKL_Complex16 b[], MKL_Complex16 r[], long long int *mode);
extern void  vmcSub (const int n, const MKL_Complex8 a[], const MKL_Complex8 b[], MKL_Complex8 r[], long long int mode);
extern void  vmzSub (const int n, const MKL_Complex16 a[], const MKL_Complex16 b[], MKL_Complex16 r[], long long int mode);


extern void  VSINV (const int *n, const float a[], float r[]);
extern void  VDINV (const int *n, const double a[], double r[]);
extern void  vsinv (const int *n, const float a[], float r[]);
extern void  vdinv (const int *n, const double a[], double r[]);
extern void  vsInv (const int n, const float a[], float r[]);
extern void  vdInv (const int n, const double a[], double r[]);

extern void  VMSINV (const int *n, const float a[], float r[], long long int *mode);
extern void  VMDINV (const int *n, const double a[], double r[], long long int *mode);
extern void  vmsinv (const int *n, const float a[], float r[], long long int *mode);
extern void  vmdinv (const int *n, const double a[], double r[], long long int *mode);
extern void  vmsInv (const int n, const float a[], float r[], long long int mode);
extern void  vmdInv (const int n, const double a[], double r[], long long int mode);


extern void  VSSQRT (const int *n, const float a[], float r[]);
extern void  VDSQRT (const int *n, const double a[], double r[]);
extern void  vssqrt (const int *n, const float a[], float r[]);
extern void  vdsqrt (const int *n, const double a[], double r[]);
extern void  vsSqrt (const int n, const float a[], float r[]);
extern void  vdSqrt (const int n, const double a[], double r[]);

extern void  VMSSQRT (const int *n, const float a[], float r[], long long int *mode);
extern void  VMDSQRT (const int *n, const double a[], double r[], long long int *mode);
extern void  vmssqrt (const int *n, const float a[], float r[], long long int *mode);
extern void  vmdsqrt (const int *n, const double a[], double r[], long long int *mode);
extern void  vmsSqrt (const int n, const float a[], float r[], long long int mode);
extern void  vmdSqrt (const int n, const double a[], double r[], long long int mode);


extern void  VCSQRT (const int *n, const MKL_Complex8 a[], MKL_Complex8 r[]);
extern void  VZSQRT (const int *n, const MKL_Complex16 a[], MKL_Complex16 r[]);
extern void  vcsqrt (const int *n, const MKL_Complex8 a[], MKL_Complex8 r[]);
extern void  vzsqrt (const int *n, const MKL_Complex16 a[], MKL_Complex16 r[]);
extern void  vcSqrt (const int n, const MKL_Complex8 a[], MKL_Complex8 r[]);
extern void  vzSqrt (const int n, const MKL_Complex16 a[], MKL_Complex16 r[]);

extern void  VMCSQRT (const int *n, const MKL_Complex8 a[], MKL_Complex8 r[], long long int *mode);
extern void  VMZSQRT (const int *n, const MKL_Complex16 a[], MKL_Complex16 r[], long long int *mode);
extern void  vmcsqrt (const int *n, const MKL_Complex8 a[], MKL_Complex8 r[], long long int *mode);
extern void  vmzsqrt (const int *n, const MKL_Complex16 a[], MKL_Complex16 r[], long long int *mode);
extern void  vmcSqrt (const int n, const MKL_Complex8 a[], MKL_Complex8 r[], long long int mode);
extern void  vmzSqrt (const int n, const MKL_Complex16 a[], MKL_Complex16 r[], long long int mode);


extern void  VSINVSQRT (const int *n, const float a[], float r[]);
extern void  VDINVSQRT (const int *n, const double a[], double r[]);
extern void  vsinvsqrt (const int *n, const float a[], float r[]);
extern void  vdinvsqrt (const int *n, const double a[], double r[]);
extern void  vsInvSqrt (const int n, const float a[], float r[]);
extern void  vdInvSqrt (const int n, const double a[], double r[]);

extern void  VMSINVSQRT (const int *n, const float a[], float r[], long long int *mode);
extern void  VMDINVSQRT (const int *n, const double a[], double r[], long long int *mode);
extern void  vmsinvsqrt (const int *n, const float a[], float r[], long long int *mode);
extern void  vmdinvsqrt (const int *n, const double a[], double r[], long long int *mode);
extern void  vmsInvSqrt (const int n, const float a[], float r[], long long int mode);
extern void  vmdInvSqrt (const int n, const double a[], double r[], long long int mode);


extern void  VSCBRT (const int *n, const float a[], float r[]);
extern void  VDCBRT (const int *n, const double a[], double r[]);
extern void  vscbrt (const int *n, const float a[], float r[]);
extern void  vdcbrt (const int *n, const double a[], double r[]);
extern void  vsCbrt (const int n, const float a[], float r[]);
extern void  vdCbrt (const int n, const double a[], double r[]);

extern void  VMSCBRT (const int *n, const float a[], float r[], long long int *mode);
extern void  VMDCBRT (const int *n, const double a[], double r[], long long int *mode);
extern void  vmscbrt (const int *n, const float a[], float r[], long long int *mode);
extern void  vmdcbrt (const int *n, const double a[], double r[], long long int *mode);
extern void  vmsCbrt (const int n, const float a[], float r[], long long int mode);
extern void  vmdCbrt (const int n, const double a[], double r[], long long int mode);


extern void  VSINVCBRT (const int *n, const float a[], float r[]);
extern void  VDINVCBRT (const int *n, const double a[], double r[]);
extern void  vsinvcbrt (const int *n, const float a[], float r[]);
extern void  vdinvcbrt (const int *n, const double a[], double r[]);
extern void  vsInvCbrt (const int n, const float a[], float r[]);
extern void  vdInvCbrt (const int n, const double a[], double r[]);

extern void  VMSINVCBRT (const int *n, const float a[], float r[], long long int *mode);
extern void  VMDINVCBRT (const int *n, const double a[], double r[], long long int *mode);
extern void  vmsinvcbrt (const int *n, const float a[], float r[], long long int *mode);
extern void  vmdinvcbrt (const int *n, const double a[], double r[], long long int *mode);
extern void  vmsInvCbrt (const int n, const float a[], float r[], long long int mode);
extern void  vmdInvCbrt (const int n, const double a[], double r[], long long int mode);


extern void  VSSQR (const int *n, const float a[], float r[]);
extern void  VDSQR (const int *n, const double a[], double r[]);
extern void  vssqr (const int *n, const float a[], float r[]);
extern void  vdsqr (const int *n, const double a[], double r[]);
extern void  vsSqr (const int n, const float a[], float r[]);
extern void  vdSqr (const int n, const double a[], double r[]);

extern void  VMSSQR (const int *n, const float a[], float r[], long long int *mode);
extern void  VMDSQR (const int *n, const double a[], double r[], long long int *mode);
extern void  vmssqr (const int *n, const float a[], float r[], long long int *mode);
extern void  vmdsqr (const int *n, const double a[], double r[], long long int *mode);
extern void  vmsSqr (const int n, const float a[], float r[], long long int mode);
extern void  vmdSqr (const int n, const double a[], double r[], long long int mode);


extern void  VSEXP (const int *n, const float a[], float r[]);
extern void  VDEXP (const int *n, const double a[], double r[]);
extern void  vsexp (const int *n, const float a[], float r[]);
extern void  vdexp (const int *n, const double a[], double r[]);
extern void  vsExp (const int n, const float a[], float r[]);
extern void  vdExp (const int n, const double a[], double r[]);

extern void  VMSEXP (const int *n, const float a[], float r[], long long int *mode);
extern void  VMDEXP (const int *n, const double a[], double r[], long long int *mode);
extern void  vmsexp (const int *n, const float a[], float r[], long long int *mode);
extern void  vmdexp (const int *n, const double a[], double r[], long long int *mode);
extern void  vmsExp (const int n, const float a[], float r[], long long int mode);
extern void  vmdExp (const int n, const double a[], double r[], long long int mode);


extern void  VSEXPM1 (const int *n, const float a[], float r[]);
extern void  VDEXPM1 (const int *n, const double a[], double r[]);
extern void  vsexpm1 (const int *n, const float a[], float r[]);
extern void  vdexpm1 (const int *n, const double a[], double r[]);
extern void  vsExpm1 (const int n, const float a[], float r[]);
extern void  vdExpm1 (const int n, const double a[], double r[]);

extern void  VMSEXPM1 (const int *n, const float a[], float r[], long long int *mode);
extern void  VMDEXPM1 (const int *n, const double a[], double r[], long long int *mode);
extern void  vmsexpm1 (const int *n, const float a[], float r[], long long int *mode);
extern void  vmdexpm1 (const int *n, const double a[], double r[], long long int *mode);
extern void  vmsExpm1 (const int n, const float a[], float r[], long long int mode);
extern void  vmdExpm1 (const int n, const double a[], double r[], long long int mode);


extern void  VCEXP (const int *n, const MKL_Complex8 a[], MKL_Complex8 r[]);
extern void  VZEXP (const int *n, const MKL_Complex16 a[], MKL_Complex16 r[]);
extern void  vcexp (const int *n, const MKL_Complex8 a[], MKL_Complex8 r[]);
extern void  vzexp (const int *n, const MKL_Complex16 a[], MKL_Complex16 r[]);
extern void  vcExp (const int n, const MKL_Complex8 a[], MKL_Complex8 r[]);
extern void  vzExp (const int n, const MKL_Complex16 a[], MKL_Complex16 r[]);

extern void  VMCEXP (const int *n, const MKL_Complex8 a[], MKL_Complex8 r[], long long int *mode);
extern void  VMZEXP (const int *n, const MKL_Complex16 a[], MKL_Complex16 r[], long long int *mode);
extern void  vmcexp (const int *n, const MKL_Complex8 a[], MKL_Complex8 r[], long long int *mode);
extern void  vmzexp (const int *n, const MKL_Complex16 a[], MKL_Complex16 r[], long long int *mode);
extern void  vmcExp (const int n, const MKL_Complex8 a[], MKL_Complex8 r[], long long int mode);
extern void  vmzExp (const int n, const MKL_Complex16 a[], MKL_Complex16 r[], long long int mode);


extern void  VSLN (const int *n, const float a[], float r[]);
extern void  VDLN (const int *n, const double a[], double r[]);
extern void  vsln (const int *n, const float a[], float r[]);
extern void  vdln (const int *n, const double a[], double r[]);
extern void  vsLn (const int n, const float a[], float r[]);
extern void  vdLn (const int n, const double a[], double r[]);

extern void  VMSLN (const int *n, const float a[], float r[], long long int *mode);
extern void  VMDLN (const int *n, const double a[], double r[], long long int *mode);
extern void  vmsln (const int *n, const float a[], float r[], long long int *mode);
extern void  vmdln (const int *n, const double a[], double r[], long long int *mode);
extern void  vmsLn (const int n, const float a[], float r[], long long int mode);
extern void  vmdLn (const int n, const double a[], double r[], long long int mode);


extern void  VCLN (const int *n, const MKL_Complex8 a[], MKL_Complex8 r[]);
extern void  VZLN (const int *n, const MKL_Complex16 a[], MKL_Complex16 r[]);
extern void  vcln (const int *n, const MKL_Complex8 a[], MKL_Complex8 r[]);
extern void  vzln (const int *n, const MKL_Complex16 a[], MKL_Complex16 r[]);
extern void  vcLn (const int n, const MKL_Complex8 a[], MKL_Complex8 r[]);
extern void  vzLn (const int n, const MKL_Complex16 a[], MKL_Complex16 r[]);

extern void  VMCLN (const int *n, const MKL_Complex8 a[], MKL_Complex8 r[], long long int *mode);
extern void  VMZLN (const int *n, const MKL_Complex16 a[], MKL_Complex16 r[], long long int *mode);
extern void  vmcln (const int *n, const MKL_Complex8 a[], MKL_Complex8 r[], long long int *mode);
extern void  vmzln (const int *n, const MKL_Complex16 a[], MKL_Complex16 r[], long long int *mode);
extern void  vmcLn (const int n, const MKL_Complex8 a[], MKL_Complex8 r[], long long int mode);
extern void  vmzLn (const int n, const MKL_Complex16 a[], MKL_Complex16 r[], long long int mode);


extern void  VSLOG10 (const int *n, const float a[], float r[]);
extern void  VDLOG10 (const int *n, const double a[], double r[]);
extern void  vslog10 (const int *n, const float a[], float r[]);
extern void  vdlog10 (const int *n, const double a[], double r[]);
extern void  vsLog10 (const int n, const float a[], float r[]);
extern void  vdLog10 (const int n, const double a[], double r[]);

extern void  VMSLOG10 (const int *n, const float a[], float r[], long long int *mode);
extern void  VMDLOG10 (const int *n, const double a[], double r[], long long int *mode);
extern void  vmslog10 (const int *n, const float a[], float r[], long long int *mode);
extern void  vmdlog10 (const int *n, const double a[], double r[], long long int *mode);
extern void  vmsLog10 (const int n, const float a[], float r[], long long int mode);
extern void  vmdLog10 (const int n, const double a[], double r[], long long int mode);


extern void  VCLOG10 (const int *n, const MKL_Complex8 a[], MKL_Complex8 r[]);
extern void  VZLOG10 (const int *n, const MKL_Complex16 a[], MKL_Complex16 r[]);
extern void  vclog10 (const int *n, const MKL_Complex8 a[], MKL_Complex8 r[]);
extern void  vzlog10 (const int *n, const MKL_Complex16 a[], MKL_Complex16 r[]);
extern void  vcLog10 (const int n, const MKL_Complex8 a[], MKL_Complex8 r[]);
extern void  vzLog10 (const int n, const MKL_Complex16 a[], MKL_Complex16 r[]);

extern void  VMCLOG10 (const int *n, const MKL_Complex8 a[], MKL_Complex8 r[], long long int *mode);
extern void  VMZLOG10 (const int *n, const MKL_Complex16 a[], MKL_Complex16 r[], long long int *mode);
extern void  vmclog10 (const int *n, const MKL_Complex8 a[], MKL_Complex8 r[], long long int *mode);
extern void  vmzlog10 (const int *n, const MKL_Complex16 a[], MKL_Complex16 r[], long long int *mode);
extern void  vmcLog10 (const int n, const MKL_Complex8 a[], MKL_Complex8 r[], long long int mode);
extern void  vmzLog10 (const int n, const MKL_Complex16 a[], MKL_Complex16 r[], long long int mode);


extern void  VSLOG1P (const int *n, const float a[], float r[]);
extern void  VDLOG1P (const int *n, const double a[], double r[]);
extern void  vslog1p (const int *n, const float a[], float r[]);
extern void  vdlog1p (const int *n, const double a[], double r[]);
extern void  vsLog1p (const int n, const float a[], float r[]);
extern void  vdLog1p (const int n, const double a[], double r[]);

extern void  VMSLOG1P (const int *n, const float a[], float r[], long long int *mode);
extern void  VMDLOG1P (const int *n, const double a[], double r[], long long int *mode);
extern void  vmslog1p (const int *n, const float a[], float r[], long long int *mode);
extern void  vmdlog1p (const int *n, const double a[], double r[], long long int *mode);
extern void  vmsLog1p (const int n, const float a[], float r[], long long int mode);
extern void  vmdLog1p (const int n, const double a[], double r[], long long int mode);


extern void  VSCOS (const int *n, const float a[], float r[]);
extern void  VDCOS (const int *n, const double a[], double r[]);
extern void  vscos (const int *n, const float a[], float r[]);
extern void  vdcos (const int *n, const double a[], double r[]);
extern void  vsCos (const int n, const float a[], float r[]);
extern void  vdCos (const int n, const double a[], double r[]);

extern void  VMSCOS (const int *n, const float a[], float r[], long long int *mode);
extern void  VMDCOS (const int *n, const double a[], double r[], long long int *mode);
extern void  vmscos (const int *n, const float a[], float r[], long long int *mode);
extern void  vmdcos (const int *n, const double a[], double r[], long long int *mode);
extern void  vmsCos (const int n, const float a[], float r[], long long int mode);
extern void  vmdCos (const int n, const double a[], double r[], long long int mode);


extern void  VCCOS (const int *n, const MKL_Complex8 a[], MKL_Complex8 r[]);
extern void  VZCOS (const int *n, const MKL_Complex16 a[], MKL_Complex16 r[]);
extern void  vccos (const int *n, const MKL_Complex8 a[], MKL_Complex8 r[]);
extern void  vzcos (const int *n, const MKL_Complex16 a[], MKL_Complex16 r[]);
extern void  vcCos (const int n, const MKL_Complex8 a[], MKL_Complex8 r[]);
extern void  vzCos (const int n, const MKL_Complex16 a[], MKL_Complex16 r[]);

extern void  VMCCOS (const int *n, const MKL_Complex8 a[], MKL_Complex8 r[], long long int *mode);
extern void  VMZCOS (const int *n, const MKL_Complex16 a[], MKL_Complex16 r[], long long int *mode);
extern void  vmccos (const int *n, const MKL_Complex8 a[], MKL_Complex8 r[], long long int *mode);
extern void  vmzcos (const int *n, const MKL_Complex16 a[], MKL_Complex16 r[], long long int *mode);
extern void  vmcCos (const int n, const MKL_Complex8 a[], MKL_Complex8 r[], long long int mode);
extern void  vmzCos (const int n, const MKL_Complex16 a[], MKL_Complex16 r[], long long int mode);


extern void  VSSIN (const int *n, const float a[], float r[]);
extern void  VDSIN (const int *n, const double a[], double r[]);
extern void  vssin (const int *n, const float a[], float r[]);
extern void  vdsin (const int *n, const double a[], double r[]);
extern void  vsSin (const int n, const float a[], float r[]);
extern void  vdSin (const int n, const double a[], double r[]);

extern void  VMSSIN (const int *n, const float a[], float r[], long long int *mode);
extern void  VMDSIN (const int *n, const double a[], double r[], long long int *mode);
extern void  vmssin (const int *n, const float a[], float r[], long long int *mode);
extern void  vmdsin (const int *n, const double a[], double r[], long long int *mode);
extern void  vmsSin (const int n, const float a[], float r[], long long int mode);
extern void  vmdSin (const int n, const double a[], double r[], long long int mode);


extern void  VCSIN (const int *n, const MKL_Complex8 a[], MKL_Complex8 r[]);
extern void  VZSIN (const int *n, const MKL_Complex16 a[], MKL_Complex16 r[]);
extern void  vcsin (const int *n, const MKL_Complex8 a[], MKL_Complex8 r[]);
extern void  vzsin (const int *n, const MKL_Complex16 a[], MKL_Complex16 r[]);
extern void  vcSin (const int n, const MKL_Complex8 a[], MKL_Complex8 r[]);
extern void  vzSin (const int n, const MKL_Complex16 a[], MKL_Complex16 r[]);

extern void  VMCSIN (const int *n, const MKL_Complex8 a[], MKL_Complex8 r[], long long int *mode);
extern void  VMZSIN (const int *n, const MKL_Complex16 a[], MKL_Complex16 r[], long long int *mode);
extern void  vmcsin (const int *n, const MKL_Complex8 a[], MKL_Complex8 r[], long long int *mode);
extern void  vmzsin (const int *n, const MKL_Complex16 a[], MKL_Complex16 r[], long long int *mode);
extern void  vmcSin (const int n, const MKL_Complex8 a[], MKL_Complex8 r[], long long int mode);
extern void  vmzSin (const int n, const MKL_Complex16 a[], MKL_Complex16 r[], long long int mode);


extern void  VSTAN (const int *n, const float a[], float r[]);
extern void  VDTAN (const int *n, const double a[], double r[]);
extern void  vstan (const int *n, const float a[], float r[]);
extern void  vdtan (const int *n, const double a[], double r[]);
extern void  vsTan (const int n, const float a[], float r[]);
extern void  vdTan (const int n, const double a[], double r[]);

extern void  VMSTAN (const int *n, const float a[], float r[], long long int *mode);
extern void  VMDTAN (const int *n, const double a[], double r[], long long int *mode);
extern void  vmstan (const int *n, const float a[], float r[], long long int *mode);
extern void  vmdtan (const int *n, const double a[], double r[], long long int *mode);
extern void  vmsTan (const int n, const float a[], float r[], long long int mode);
extern void  vmdTan (const int n, const double a[], double r[], long long int mode);


extern void  VCTAN (const int *n, const MKL_Complex8 a[], MKL_Complex8 r[]);
extern void  VZTAN (const int *n, const MKL_Complex16 a[], MKL_Complex16 r[]);
extern void  vctan (const int *n, const MKL_Complex8 a[], MKL_Complex8 r[]);
extern void  vztan (const int *n, const MKL_Complex16 a[], MKL_Complex16 r[]);
extern void  vcTan (const int n, const MKL_Complex8 a[], MKL_Complex8 r[]);
extern void  vzTan (const int n, const MKL_Complex16 a[], MKL_Complex16 r[]);

extern void  VMCTAN (const int *n, const MKL_Complex8 a[], MKL_Complex8 r[], long long int *mode);
extern void  VMZTAN (const int *n, const MKL_Complex16 a[], MKL_Complex16 r[], long long int *mode);
extern void  vmctan (const int *n, const MKL_Complex8 a[], MKL_Complex8 r[], long long int *mode);
extern void  vmztan (const int *n, const MKL_Complex16 a[], MKL_Complex16 r[], long long int *mode);
extern void  vmcTan (const int n, const MKL_Complex8 a[], MKL_Complex8 r[], long long int mode);
extern void  vmzTan (const int n, const MKL_Complex16 a[], MKL_Complex16 r[], long long int mode);


extern void  VSCOSH (const int *n, const float a[], float r[]);
extern void  VDCOSH (const int *n, const double a[], double r[]);
extern void  vscosh (const int *n, const float a[], float r[]);
extern void  vdcosh (const int *n, const double a[], double r[]);
extern void  vsCosh (const int n, const float a[], float r[]);
extern void  vdCosh (const int n, const double a[], double r[]);

extern void  VMSCOSH (const int *n, const float a[], float r[], long long int *mode);
extern void  VMDCOSH (const int *n, const double a[], double r[], long long int *mode);
extern void  vmscosh (const int *n, const float a[], float r[], long long int *mode);
extern void  vmdcosh (const int *n, const double a[], double r[], long long int *mode);
extern void  vmsCosh (const int n, const float a[], float r[], long long int mode);
extern void  vmdCosh (const int n, const double a[], double r[], long long int mode);


extern void  VCCOSH (const int *n, const MKL_Complex8 a[], MKL_Complex8 r[]);
extern void  VZCOSH (const int *n, const MKL_Complex16 a[], MKL_Complex16 r[]);
extern void  vccosh (const int *n, const MKL_Complex8 a[], MKL_Complex8 r[]);
extern void  vzcosh (const int *n, const MKL_Complex16 a[], MKL_Complex16 r[]);
extern void  vcCosh (const int n, const MKL_Complex8 a[], MKL_Complex8 r[]);
extern void  vzCosh (const int n, const MKL_Complex16 a[], MKL_Complex16 r[]);

extern void  VMCCOSH (const int *n, const MKL_Complex8 a[], MKL_Complex8 r[], long long int *mode);
extern void  VMZCOSH (const int *n, const MKL_Complex16 a[], MKL_Complex16 r[], long long int *mode);
extern void  vmccosh (const int *n, const MKL_Complex8 a[], MKL_Complex8 r[], long long int *mode);
extern void  vmzcosh (const int *n, const MKL_Complex16 a[], MKL_Complex16 r[], long long int *mode);
extern void  vmcCosh (const int n, const MKL_Complex8 a[], MKL_Complex8 r[], long long int mode);
extern void  vmzCosh (const int n, const MKL_Complex16 a[], MKL_Complex16 r[], long long int mode);


extern void  VSSINH (const int *n, const float a[], float r[]);
extern void  VDSINH (const int *n, const double a[], double r[]);
extern void  vssinh (const int *n, const float a[], float r[]);
extern void  vdsinh (const int *n, const double a[], double r[]);
extern void  vsSinh (const int n, const float a[], float r[]);
extern void  vdSinh (const int n, const double a[], double r[]);

extern void  VMSSINH (const int *n, const float a[], float r[], long long int *mode);
extern void  VMDSINH (const int *n, const double a[], double r[], long long int *mode);
extern void  vmssinh (const int *n, const float a[], float r[], long long int *mode);
extern void  vmdsinh (const int *n, const double a[], double r[], long long int *mode);
extern void  vmsSinh (const int n, const float a[], float r[], long long int mode);
extern void  vmdSinh (const int n, const double a[], double r[], long long int mode);


extern void  VCSINH (const int *n, const MKL_Complex8 a[], MKL_Complex8 r[]);
extern void  VZSINH (const int *n, const MKL_Complex16 a[], MKL_Complex16 r[]);
extern void  vcsinh (const int *n, const MKL_Complex8 a[], MKL_Complex8 r[]);
extern void  vzsinh (const int *n, const MKL_Complex16 a[], MKL_Complex16 r[]);
extern void  vcSinh (const int n, const MKL_Complex8 a[], MKL_Complex8 r[]);
extern void  vzSinh (const int n, const MKL_Complex16 a[], MKL_Complex16 r[]);

extern void  VMCSINH (const int *n, const MKL_Complex8 a[], MKL_Complex8 r[], long long int *mode);
extern void  VMZSINH (const int *n, const MKL_Complex16 a[], MKL_Complex16 r[], long long int *mode);
extern void  vmcsinh (const int *n, const MKL_Complex8 a[], MKL_Complex8 r[], long long int *mode);
extern void  vmzsinh (const int *n, const MKL_Complex16 a[], MKL_Complex16 r[], long long int *mode);
extern void  vmcSinh (const int n, const MKL_Complex8 a[], MKL_Complex8 r[], long long int mode);
extern void  vmzSinh (const int n, const MKL_Complex16 a[], MKL_Complex16 r[], long long int mode);


extern void  VSTANH (const int *n, const float a[], float r[]);
extern void  VDTANH (const int *n, const double a[], double r[]);
extern void  vstanh (const int *n, const float a[], float r[]);
extern void  vdtanh (const int *n, const double a[], double r[]);
extern void  vsTanh (const int n, const float a[], float r[]);
extern void  vdTanh (const int n, const double a[], double r[]);

extern void  VMSTANH (const int *n, const float a[], float r[], long long int *mode);
extern void  VMDTANH (const int *n, const double a[], double r[], long long int *mode);
extern void  vmstanh (const int *n, const float a[], float r[], long long int *mode);
extern void  vmdtanh (const int *n, const double a[], double r[], long long int *mode);
extern void  vmsTanh (const int n, const float a[], float r[], long long int mode);
extern void  vmdTanh (const int n, const double a[], double r[], long long int mode);


extern void  VCTANH (const int *n, const MKL_Complex8 a[], MKL_Complex8 r[]);
extern void  VZTANH (const int *n, const MKL_Complex16 a[], MKL_Complex16 r[]);
extern void  vctanh (const int *n, const MKL_Complex8 a[], MKL_Complex8 r[]);
extern void  vztanh (const int *n, const MKL_Complex16 a[], MKL_Complex16 r[]);
extern void  vcTanh (const int n, const MKL_Complex8 a[], MKL_Complex8 r[]);
extern void  vzTanh (const int n, const MKL_Complex16 a[], MKL_Complex16 r[]);

extern void  VMCTANH (const int *n, const MKL_Complex8 a[], MKL_Complex8 r[], long long int *mode);
extern void  VMZTANH (const int *n, const MKL_Complex16 a[], MKL_Complex16 r[], long long int *mode);
extern void  vmctanh (const int *n, const MKL_Complex8 a[], MKL_Complex8 r[], long long int *mode);
extern void  vmztanh (const int *n, const MKL_Complex16 a[], MKL_Complex16 r[], long long int *mode);
extern void  vmcTanh (const int n, const MKL_Complex8 a[], MKL_Complex8 r[], long long int mode);
extern void  vmzTanh (const int n, const MKL_Complex16 a[], MKL_Complex16 r[], long long int mode);


extern void  VSACOS (const int *n, const float a[], float r[]);
extern void  VDACOS (const int *n, const double a[], double r[]);
extern void  vsacos (const int *n, const float a[], float r[]);
extern void  vdacos (const int *n, const double a[], double r[]);
extern void  vsAcos (const int n, const float a[], float r[]);
extern void  vdAcos (const int n, const double a[], double r[]);

extern void  VMSACOS (const int *n, const float a[], float r[], long long int *mode);
extern void  VMDACOS (const int *n, const double a[], double r[], long long int *mode);
extern void  vmsacos (const int *n, const float a[], float r[], long long int *mode);
extern void  vmdacos (const int *n, const double a[], double r[], long long int *mode);
extern void  vmsAcos (const int n, const float a[], float r[], long long int mode);
extern void  vmdAcos (const int n, const double a[], double r[], long long int mode);


extern void  VCACOS (const int *n, const MKL_Complex8 a[], MKL_Complex8 r[]);
extern void  VZACOS (const int *n, const MKL_Complex16 a[], MKL_Complex16 r[]);
extern void  vcacos (const int *n, const MKL_Complex8 a[], MKL_Complex8 r[]);
extern void  vzacos (const int *n, const MKL_Complex16 a[], MKL_Complex16 r[]);
extern void  vcAcos (const int n, const MKL_Complex8 a[], MKL_Complex8 r[]);
extern void  vzAcos (const int n, const MKL_Complex16 a[], MKL_Complex16 r[]);

extern void  VMCACOS (const int *n, const MKL_Complex8 a[], MKL_Complex8 r[], long long int *mode);
extern void  VMZACOS (const int *n, const MKL_Complex16 a[], MKL_Complex16 r[], long long int *mode);
extern void  vmcacos (const int *n, const MKL_Complex8 a[], MKL_Complex8 r[], long long int *mode);
extern void  vmzacos (const int *n, const MKL_Complex16 a[], MKL_Complex16 r[], long long int *mode);
extern void  vmcAcos (const int n, const MKL_Complex8 a[], MKL_Complex8 r[], long long int mode);
extern void  vmzAcos (const int n, const MKL_Complex16 a[], MKL_Complex16 r[], long long int mode);


extern void  VSASIN (const int *n, const float a[], float r[]);
extern void  VDASIN (const int *n, const double a[], double r[]);
extern void  vsasin (const int *n, const float a[], float r[]);
extern void  vdasin (const int *n, const double a[], double r[]);
extern void  vsAsin (const int n, const float a[], float r[]);
extern void  vdAsin (const int n, const double a[], double r[]);

extern void  VMSASIN (const int *n, const float a[], float r[], long long int *mode);
extern void  VMDASIN (const int *n, const double a[], double r[], long long int *mode);
extern void  vmsasin (const int *n, const float a[], float r[], long long int *mode);
extern void  vmdasin (const int *n, const double a[], double r[], long long int *mode);
extern void  vmsAsin (const int n, const float a[], float r[], long long int mode);
extern void  vmdAsin (const int n, const double a[], double r[], long long int mode);


extern void  VCASIN (const int *n, const MKL_Complex8 a[], MKL_Complex8 r[]);
extern void  VZASIN (const int *n, const MKL_Complex16 a[], MKL_Complex16 r[]);
extern void  vcasin (const int *n, const MKL_Complex8 a[], MKL_Complex8 r[]);
extern void  vzasin (const int *n, const MKL_Complex16 a[], MKL_Complex16 r[]);
extern void  vcAsin (const int n, const MKL_Complex8 a[], MKL_Complex8 r[]);
extern void  vzAsin (const int n, const MKL_Complex16 a[], MKL_Complex16 r[]);

extern void  VMCASIN (const int *n, const MKL_Complex8 a[], MKL_Complex8 r[], long long int *mode);
extern void  VMZASIN (const int *n, const MKL_Complex16 a[], MKL_Complex16 r[], long long int *mode);
extern void  vmcasin (const int *n, const MKL_Complex8 a[], MKL_Complex8 r[], long long int *mode);
extern void  vmzasin (const int *n, const MKL_Complex16 a[], MKL_Complex16 r[], long long int *mode);
extern void  vmcAsin (const int n, const MKL_Complex8 a[], MKL_Complex8 r[], long long int mode);
extern void  vmzAsin (const int n, const MKL_Complex16 a[], MKL_Complex16 r[], long long int mode);


extern void  VSATAN (const int *n, const float a[], float r[]);
extern void  VDATAN (const int *n, const double a[], double r[]);
extern void  vsatan (const int *n, const float a[], float r[]);
extern void  vdatan (const int *n, const double a[], double r[]);
extern void  vsAtan (const int n, const float a[], float r[]);
extern void  vdAtan (const int n, const double a[], double r[]);

extern void  VMSATAN (const int *n, const float a[], float r[], long long int *mode);
extern void  VMDATAN (const int *n, const double a[], double r[], long long int *mode);
extern void  vmsatan (const int *n, const float a[], float r[], long long int *mode);
extern void  vmdatan (const int *n, const double a[], double r[], long long int *mode);
extern void  vmsAtan (const int n, const float a[], float r[], long long int mode);
extern void  vmdAtan (const int n, const double a[], double r[], long long int mode);


extern void  VCATAN (const int *n, const MKL_Complex8 a[], MKL_Complex8 r[]);
extern void  VZATAN (const int *n, const MKL_Complex16 a[], MKL_Complex16 r[]);
extern void  vcatan (const int *n, const MKL_Complex8 a[], MKL_Complex8 r[]);
extern void  vzatan (const int *n, const MKL_Complex16 a[], MKL_Complex16 r[]);
extern void  vcAtan (const int n, const MKL_Complex8 a[], MKL_Complex8 r[]);
extern void  vzAtan (const int n, const MKL_Complex16 a[], MKL_Complex16 r[]);

extern void  VMCATAN (const int *n, const MKL_Complex8 a[], MKL_Complex8 r[], long long int *mode);
extern void  VMZATAN (const int *n, const MKL_Complex16 a[], MKL_Complex16 r[], long long int *mode);
extern void  vmcatan (const int *n, const MKL_Complex8 a[], MKL_Complex8 r[], long long int *mode);
extern void  vmzatan (const int *n, const MKL_Complex16 a[], MKL_Complex16 r[], long long int *mode);
extern void  vmcAtan (const int n, const MKL_Complex8 a[], MKL_Complex8 r[], long long int mode);
extern void  vmzAtan (const int n, const MKL_Complex16 a[], MKL_Complex16 r[], long long int mode);


extern void  VSACOSH (const int *n, const float a[], float r[]);
extern void  VDACOSH (const int *n, const double a[], double r[]);
extern void  vsacosh (const int *n, const float a[], float r[]);
extern void  vdacosh (const int *n, const double a[], double r[]);
extern void  vsAcosh (const int n, const float a[], float r[]);
extern void  vdAcosh (const int n, const double a[], double r[]);

extern void  VMSACOSH (const int *n, const float a[], float r[], long long int *mode);
extern void  VMDACOSH (const int *n, const double a[], double r[], long long int *mode);
extern void  vmsacosh (const int *n, const float a[], float r[], long long int *mode);
extern void  vmdacosh (const int *n, const double a[], double r[], long long int *mode);
extern void  vmsAcosh (const int n, const float a[], float r[], long long int mode);
extern void  vmdAcosh (const int n, const double a[], double r[], long long int mode);


extern void  VCACOSH (const int *n, const MKL_Complex8 a[], MKL_Complex8 r[]);
extern void  VZACOSH (const int *n, const MKL_Complex16 a[], MKL_Complex16 r[]);
extern void  vcacosh (const int *n, const MKL_Complex8 a[], MKL_Complex8 r[]);
extern void  vzacosh (const int *n, const MKL_Complex16 a[], MKL_Complex16 r[]);
extern void  vcAcosh (const int n, const MKL_Complex8 a[], MKL_Complex8 r[]);
extern void  vzAcosh (const int n, const MKL_Complex16 a[], MKL_Complex16 r[]);

extern void  VMCACOSH (const int *n, const MKL_Complex8 a[], MKL_Complex8 r[], long long int *mode);
extern void  VMZACOSH (const int *n, const MKL_Complex16 a[], MKL_Complex16 r[], long long int *mode);
extern void  vmcacosh (const int *n, const MKL_Complex8 a[], MKL_Complex8 r[], long long int *mode);
extern void  vmzacosh (const int *n, const MKL_Complex16 a[], MKL_Complex16 r[], long long int *mode);
extern void  vmcAcosh (const int n, const MKL_Complex8 a[], MKL_Complex8 r[], long long int mode);
extern void  vmzAcosh (const int n, const MKL_Complex16 a[], MKL_Complex16 r[], long long int mode);


extern void  VSASINH (const int *n, const float a[], float r[]);
extern void  VDASINH (const int *n, const double a[], double r[]);
extern void  vsasinh (const int *n, const float a[], float r[]);
extern void  vdasinh (const int *n, const double a[], double r[]);
extern void  vsAsinh (const int n, const float a[], float r[]);
extern void  vdAsinh (const int n, const double a[], double r[]);

extern void  VMSASINH (const int *n, const float a[], float r[], long long int *mode);
extern void  VMDASINH (const int *n, const double a[], double r[], long long int *mode);
extern void  vmsasinh (const int *n, const float a[], float r[], long long int *mode);
extern void  vmdasinh (const int *n, const double a[], double r[], long long int *mode);
extern void  vmsAsinh (const int n, const float a[], float r[], long long int mode);
extern void  vmdAsinh (const int n, const double a[], double r[], long long int mode);


extern void  VCASINH (const int *n, const MKL_Complex8 a[], MKL_Complex8 r[]);
extern void  VZASINH (const int *n, const MKL_Complex16 a[], MKL_Complex16 r[]);
extern void  vcasinh (const int *n, const MKL_Complex8 a[], MKL_Complex8 r[]);
extern void  vzasinh (const int *n, const MKL_Complex16 a[], MKL_Complex16 r[]);
extern void  vcAsinh (const int n, const MKL_Complex8 a[], MKL_Complex8 r[]);
extern void  vzAsinh (const int n, const MKL_Complex16 a[], MKL_Complex16 r[]);

extern void  VMCASINH (const int *n, const MKL_Complex8 a[], MKL_Complex8 r[], long long int *mode);
extern void  VMZASINH (const int *n, const MKL_Complex16 a[], MKL_Complex16 r[], long long int *mode);
extern void  vmcasinh (const int *n, const MKL_Complex8 a[], MKL_Complex8 r[], long long int *mode);
extern void  vmzasinh (const int *n, const MKL_Complex16 a[], MKL_Complex16 r[], long long int *mode);
extern void  vmcAsinh (const int n, const MKL_Complex8 a[], MKL_Complex8 r[], long long int mode);
extern void  vmzAsinh (const int n, const MKL_Complex16 a[], MKL_Complex16 r[], long long int mode);


extern void  VSATANH (const int *n, const float a[], float r[]);
extern void  VDATANH (const int *n, const double a[], double r[]);
extern void  vsatanh (const int *n, const float a[], float r[]);
extern void  vdatanh (const int *n, const double a[], double r[]);
extern void  vsAtanh (const int n, const float a[], float r[]);
extern void  vdAtanh (const int n, const double a[], double r[]);

extern void  VMSATANH (const int *n, const float a[], float r[], long long int *mode);
extern void  VMDATANH (const int *n, const double a[], double r[], long long int *mode);
extern void  vmsatanh (const int *n, const float a[], float r[], long long int *mode);
extern void  vmdatanh (const int *n, const double a[], double r[], long long int *mode);
extern void  vmsAtanh (const int n, const float a[], float r[], long long int mode);
extern void  vmdAtanh (const int n, const double a[], double r[], long long int mode);


extern void  VCATANH (const int *n, const MKL_Complex8 a[], MKL_Complex8 r[]);
extern void  VZATANH (const int *n, const MKL_Complex16 a[], MKL_Complex16 r[]);
extern void  vcatanh (const int *n, const MKL_Complex8 a[], MKL_Complex8 r[]);
extern void  vzatanh (const int *n, const MKL_Complex16 a[], MKL_Complex16 r[]);
extern void  vcAtanh (const int n, const MKL_Complex8 a[], MKL_Complex8 r[]);
extern void  vzAtanh (const int n, const MKL_Complex16 a[], MKL_Complex16 r[]);

extern void  VMCATANH (const int *n, const MKL_Complex8 a[], MKL_Complex8 r[], long long int *mode);
extern void  VMZATANH (const int *n, const MKL_Complex16 a[], MKL_Complex16 r[], long long int *mode);
extern void  vmcatanh (const int *n, const MKL_Complex8 a[], MKL_Complex8 r[], long long int *mode);
extern void  vmzatanh (const int *n, const MKL_Complex16 a[], MKL_Complex16 r[], long long int *mode);
extern void  vmcAtanh (const int n, const MKL_Complex8 a[], MKL_Complex8 r[], long long int mode);
extern void  vmzAtanh (const int n, const MKL_Complex16 a[], MKL_Complex16 r[], long long int mode);


extern void  VSERF (const int *n, const float a[], float r[]);
extern void  VDERF (const int *n, const double a[], double r[]);
extern void  vserf (const int *n, const float a[], float r[]);
extern void  vderf (const int *n, const double a[], double r[]);
extern void  vsErf (const int n, const float a[], float r[]);
extern void  vdErf (const int n, const double a[], double r[]);

extern void  VMSERF (const int *n, const float a[], float r[], long long int *mode);
extern void  VMDERF (const int *n, const double a[], double r[], long long int *mode);
extern void  vmserf (const int *n, const float a[], float r[], long long int *mode);
extern void  vmderf (const int *n, const double a[], double r[], long long int *mode);
extern void  vmsErf (const int n, const float a[], float r[], long long int mode);
extern void  vmdErf (const int n, const double a[], double r[], long long int mode);


extern void  VSERFINV (const int *n, const float a[], float r[]);
extern void  VDERFINV (const int *n, const double a[], double r[]);
extern void  vserfinv (const int *n, const float a[], float r[]);
extern void  vderfinv (const int *n, const double a[], double r[]);
extern void  vsErfInv (const int n, const float a[], float r[]);
extern void  vdErfInv (const int n, const double a[], double r[]);

extern void  VMSERFINV (const int *n, const float a[], float r[], long long int *mode);
extern void  VMDERFINV (const int *n, const double a[], double r[], long long int *mode);
extern void  vmserfinv (const int *n, const float a[], float r[], long long int *mode);
extern void  vmderfinv (const int *n, const double a[], double r[], long long int *mode);
extern void  vmsErfInv (const int n, const float a[], float r[], long long int mode);
extern void  vmdErfInv (const int n, const double a[], double r[], long long int mode);


extern void  VSHYPOT (const int *n, const float a[], const float b[], float r[]);
extern void  VDHYPOT (const int *n, const double a[], const double b[], double r[]);
extern void  vshypot (const int *n, const float a[], const float b[], float r[]);
extern void  vdhypot (const int *n, const double a[], const double b[], double r[]);
extern void  vsHypot (const int n, const float a[], const float b[], float r[]);
extern void  vdHypot (const int n, const double a[], const double b[], double r[]);

extern void  VMSHYPOT (const int *n, const float a[], const float b[], float r[], long long int *mode);
extern void  VMDHYPOT (const int *n, const double a[], const double b[], double r[], long long int *mode);
extern void  vmshypot (const int *n, const float a[], const float b[], float r[], long long int *mode);
extern void  vmdhypot (const int *n, const double a[], const double b[], double r[], long long int *mode);
extern void  vmsHypot (const int n, const float a[], const float b[], float r[], long long int mode);
extern void  vmdHypot (const int n, const double a[], const double b[], double r[], long long int mode);


extern void  VSERFC (const int *n, const float a[], float r[]);
extern void  VDERFC (const int *n, const double a[], double r[]);
extern void  vserfc (const int *n, const float a[], float r[]);
extern void  vderfc (const int *n, const double a[], double r[]);
extern void  vsErfc (const int n, const float a[], float r[]);
extern void  vdErfc (const int n, const double a[], double r[]);

extern void  VMSERFC (const int *n, const float a[], float r[], long long int *mode);
extern void  VMDERFC (const int *n, const double a[], double r[], long long int *mode);
extern void  vmserfc (const int *n, const float a[], float r[], long long int *mode);
extern void  vmderfc (const int *n, const double a[], double r[], long long int *mode);
extern void  vmsErfc (const int n, const float a[], float r[], long long int mode);
extern void  vmdErfc (const int n, const double a[], double r[], long long int mode);


extern void  VSERFCINV (const int *n, const float a[], float r[]);
extern void  VDERFCINV (const int *n, const double a[], double r[]);
extern void  vserfcinv (const int *n, const float a[], float r[]);
extern void  vderfcinv (const int *n, const double a[], double r[]);
extern void  vsErfcInv (const int n, const float a[], float r[]);
extern void  vdErfcInv (const int n, const double a[], double r[]);

extern void  VMSERFCINV (const int *n, const float a[], float r[], long long int *mode);
extern void  VMDERFCINV (const int *n, const double a[], double r[], long long int *mode);
extern void  vmserfcinv (const int *n, const float a[], float r[], long long int *mode);
extern void  vmderfcinv (const int *n, const double a[], double r[], long long int *mode);
extern void  vmsErfcInv (const int n, const float a[], float r[], long long int mode);
extern void  vmdErfcInv (const int n, const double a[], double r[], long long int mode);


extern void  VSCDFNORM (const int *n, const float a[], float r[]);
extern void  VDCDFNORM (const int *n, const double a[], double r[]);
extern void  vscdfnorm (const int *n, const float a[], float r[]);
extern void  vdcdfnorm (const int *n, const double a[], double r[]);
extern void  vsCdfNorm (const int n, const float a[], float r[]);
extern void  vdCdfNorm (const int n, const double a[], double r[]);

extern void  VMSCDFNORM (const int *n, const float a[], float r[], long long int *mode);
extern void  VMDCDFNORM (const int *n, const double a[], double r[], long long int *mode);
extern void  vmscdfnorm (const int *n, const float a[], float r[], long long int *mode);
extern void  vmdcdfnorm (const int *n, const double a[], double r[], long long int *mode);
extern void  vmsCdfNorm (const int n, const float a[], float r[], long long int mode);
extern void  vmdCdfNorm (const int n, const double a[], double r[], long long int mode);


extern void  VSCDFNORMINV (const int *n, const float a[], float r[]);
extern void  VDCDFNORMINV (const int *n, const double a[], double r[]);
extern void  vscdfnorminv (const int *n, const float a[], float r[]);
extern void  vdcdfnorminv (const int *n, const double a[], double r[]);
extern void  vsCdfNormInv (const int n, const float a[], float r[]);
extern void  vdCdfNormInv (const int n, const double a[], double r[]);

extern void  VMSCDFNORMINV (const int *n, const float a[], float r[], long long int *mode);
extern void  VMDCDFNORMINV (const int *n, const double a[], double r[], long long int *mode);
extern void  vmscdfnorminv (const int *n, const float a[], float r[], long long int *mode);
extern void  vmdcdfnorminv (const int *n, const double a[], double r[], long long int *mode);
extern void  vmsCdfNormInv (const int n, const float a[], float r[], long long int mode);
extern void  vmdCdfNormInv (const int n, const double a[], double r[], long long int mode);


extern void  VSLGAMMA (const int *n, const float a[], float r[]);
extern void  VDLGAMMA (const int *n, const double a[], double r[]);
extern void  vslgamma (const int *n, const float a[], float r[]);
extern void  vdlgamma (const int *n, const double a[], double r[]);
extern void  vsLGamma (const int n, const float a[], float r[]);
extern void  vdLGamma (const int n, const double a[], double r[]);

extern void  VMSLGAMMA (const int *n, const float a[], float r[], long long int *mode);
extern void  VMDLGAMMA (const int *n, const double a[], double r[], long long int *mode);
extern void  vmslgamma (const int *n, const float a[], float r[], long long int *mode);
extern void  vmdlgamma (const int *n, const double a[], double r[], long long int *mode);
extern void  vmsLGamma (const int n, const float a[], float r[], long long int mode);
extern void  vmdLGamma (const int n, const double a[], double r[], long long int mode);


extern void  VSTGAMMA (const int *n, const float a[], float r[]);
extern void  VDTGAMMA (const int *n, const double a[], double r[]);
extern void  vstgamma (const int *n, const float a[], float r[]);
extern void  vdtgamma (const int *n, const double a[], double r[]);
extern void  vsTGamma (const int n, const float a[], float r[]);
extern void  vdTGamma (const int n, const double a[], double r[]);

extern void  VMSTGAMMA (const int *n, const float a[], float r[], long long int *mode);
extern void  VMDTGAMMA (const int *n, const double a[], double r[], long long int *mode);
extern void  vmstgamma (const int *n, const float a[], float r[], long long int *mode);
extern void  vmdtgamma (const int *n, const double a[], double r[], long long int *mode);
extern void  vmsTGamma (const int n, const float a[], float r[], long long int mode);
extern void  vmdTGamma (const int n, const double a[], double r[], long long int mode);


extern void  VSATAN2 (const int *n, const float a[], const float b[], float r[]);
extern void  VDATAN2 (const int *n, const double a[], const double b[], double r[]);
extern void  vsatan2 (const int *n, const float a[], const float b[], float r[]);
extern void  vdatan2 (const int *n, const double a[], const double b[], double r[]);
extern void  vsAtan2 (const int n, const float a[], const float b[], float r[]);
extern void  vdAtan2 (const int n, const double a[], const double b[], double r[]);

extern void  VMSATAN2 (const int *n, const float a[], const float b[], float r[], long long int *mode);
extern void  VMDATAN2 (const int *n, const double a[], const double b[], double r[], long long int *mode);
extern void  vmsatan2 (const int *n, const float a[], const float b[], float r[], long long int *mode);
extern void  vmdatan2 (const int *n, const double a[], const double b[], double r[], long long int *mode);
extern void  vmsAtan2 (const int n, const float a[], const float b[], float r[], long long int mode);
extern void  vmdAtan2 (const int n, const double a[], const double b[], double r[], long long int mode);


extern void  VSMUL (const int *n, const float a[], const float b[], float r[]);
extern void  VDMUL (const int *n, const double a[], const double b[], double r[]);
extern void  vsmul (const int *n, const float a[], const float b[], float r[]);
extern void  vdmul (const int *n, const double a[], const double b[], double r[]);
extern void  vsMul (const int n, const float a[], const float b[], float r[]);
extern void  vdMul (const int n, const double a[], const double b[], double r[]);

extern void  VMSMUL (const int *n, const float a[], const float b[], float r[], long long int *mode);
extern void  VMDMUL (const int *n, const double a[], const double b[], double r[], long long int *mode);
extern void  vmsmul (const int *n, const float a[], const float b[], float r[], long long int *mode);
extern void  vmdmul (const int *n, const double a[], const double b[], double r[], long long int *mode);
extern void  vmsMul (const int n, const float a[], const float b[], float r[], long long int mode);
extern void  vmdMul (const int n, const double a[], const double b[], double r[], long long int mode);


extern void  VCMUL (const int *n, const MKL_Complex8 a[], const MKL_Complex8 b[], MKL_Complex8 r[]);
extern void  VZMUL (const int *n, const MKL_Complex16 a[], const MKL_Complex16 b[], MKL_Complex16 r[]);
extern void  vcmul (const int *n, const MKL_Complex8 a[], const MKL_Complex8 b[], MKL_Complex8 r[]);
extern void  vzmul (const int *n, const MKL_Complex16 a[], const MKL_Complex16 b[], MKL_Complex16 r[]);
extern void  vcMul (const int n, const MKL_Complex8 a[], const MKL_Complex8 b[], MKL_Complex8 r[]);
extern void  vzMul (const int n, const MKL_Complex16 a[], const MKL_Complex16 b[], MKL_Complex16 r[]);

extern void  VMCMUL (const int *n, const MKL_Complex8 a[], const MKL_Complex8 b[], MKL_Complex8 r[], long long int *mode);
extern void  VMZMUL (const int *n, const MKL_Complex16 a[], const MKL_Complex16 b[], MKL_Complex16 r[], long long int *mode);
extern void  vmcmul (const int *n, const MKL_Complex8 a[], const MKL_Complex8 b[], MKL_Complex8 r[], long long int *mode);
extern void  vmzmul (const int *n, const MKL_Complex16 a[], const MKL_Complex16 b[], MKL_Complex16 r[], long long int *mode);
extern void  vmcMul (const int n, const MKL_Complex8 a[], const MKL_Complex8 b[], MKL_Complex8 r[], long long int mode);
extern void  vmzMul (const int n, const MKL_Complex16 a[], const MKL_Complex16 b[], MKL_Complex16 r[], long long int mode);


extern void  VSDIV (const int *n, const float a[], const float b[], float r[]);
extern void  VDDIV (const int *n, const double a[], const double b[], double r[]);
extern void  vsdiv (const int *n, const float a[], const float b[], float r[]);
extern void  vddiv (const int *n, const double a[], const double b[], double r[]);
extern void  vsDiv (const int n, const float a[], const float b[], float r[]);
extern void  vdDiv (const int n, const double a[], const double b[], double r[]);

extern void  VMSDIV (const int *n, const float a[], const float b[], float r[], long long int *mode);
extern void  VMDDIV (const int *n, const double a[], const double b[], double r[], long long int *mode);
extern void  vmsdiv (const int *n, const float a[], const float b[], float r[], long long int *mode);
extern void  vmddiv (const int *n, const double a[], const double b[], double r[], long long int *mode);
extern void  vmsDiv (const int n, const float a[], const float b[], float r[], long long int mode);
extern void  vmdDiv (const int n, const double a[], const double b[], double r[], long long int mode);


extern void  VCDIV (const int *n, const MKL_Complex8 a[], const MKL_Complex8 b[], MKL_Complex8 r[]);
extern void  VZDIV (const int *n, const MKL_Complex16 a[], const MKL_Complex16 b[], MKL_Complex16 r[]);
extern void  vcdiv (const int *n, const MKL_Complex8 a[], const MKL_Complex8 b[], MKL_Complex8 r[]);
extern void  vzdiv (const int *n, const MKL_Complex16 a[], const MKL_Complex16 b[], MKL_Complex16 r[]);
extern void  vcDiv (const int n, const MKL_Complex8 a[], const MKL_Complex8 b[], MKL_Complex8 r[]);
extern void  vzDiv (const int n, const MKL_Complex16 a[], const MKL_Complex16 b[], MKL_Complex16 r[]);

extern void  VMCDIV (const int *n, const MKL_Complex8 a[], const MKL_Complex8 b[], MKL_Complex8 r[], long long int *mode);
extern void  VMZDIV (const int *n, const MKL_Complex16 a[], const MKL_Complex16 b[], MKL_Complex16 r[], long long int *mode);
extern void  vmcdiv (const int *n, const MKL_Complex8 a[], const MKL_Complex8 b[], MKL_Complex8 r[], long long int *mode);
extern void  vmzdiv (const int *n, const MKL_Complex16 a[], const MKL_Complex16 b[], MKL_Complex16 r[], long long int *mode);
extern void  vmcDiv (const int n, const MKL_Complex8 a[], const MKL_Complex8 b[], MKL_Complex8 r[], long long int mode);
extern void  vmzDiv (const int n, const MKL_Complex16 a[], const MKL_Complex16 b[], MKL_Complex16 r[], long long int mode);


extern void  VSPOW (const int *n, const float a[], const float b[], float r[]);
extern void  VDPOW (const int *n, const double a[], const double b[], double r[]);
extern void  vspow (const int *n, const float a[], const float b[], float r[]);
extern void  vdpow (const int *n, const double a[], const double b[], double r[]);
extern void  vsPow (const int n, const float a[], const float b[], float r[]);
extern void  vdPow (const int n, const double a[], const double b[], double r[]);

extern void  VMSPOW (const int *n, const float a[], const float b[], float r[], long long int *mode);
extern void  VMDPOW (const int *n, const double a[], const double b[], double r[], long long int *mode);
extern void  vmspow (const int *n, const float a[], const float b[], float r[], long long int *mode);
extern void  vmdpow (const int *n, const double a[], const double b[], double r[], long long int *mode);
extern void  vmsPow (const int n, const float a[], const float b[], float r[], long long int mode);
extern void  vmdPow (const int n, const double a[], const double b[], double r[], long long int mode);


extern void  VCPOW (const int *n, const MKL_Complex8 a[], const MKL_Complex8 b[], MKL_Complex8 r[]);
extern void  VZPOW (const int *n, const MKL_Complex16 a[], const MKL_Complex16 b[], MKL_Complex16 r[]);
extern void  vcpow (const int *n, const MKL_Complex8 a[], const MKL_Complex8 b[], MKL_Complex8 r[]);
extern void  vzpow (const int *n, const MKL_Complex16 a[], const MKL_Complex16 b[], MKL_Complex16 r[]);
extern void  vcPow (const int n, const MKL_Complex8 a[], const MKL_Complex8 b[], MKL_Complex8 r[]);
extern void  vzPow (const int n, const MKL_Complex16 a[], const MKL_Complex16 b[], MKL_Complex16 r[]);

extern void  VMCPOW (const int *n, const MKL_Complex8 a[], const MKL_Complex8 b[], MKL_Complex8 r[], long long int *mode);
extern void  VMZPOW (const int *n, const MKL_Complex16 a[], const MKL_Complex16 b[], MKL_Complex16 r[], long long int *mode);
extern void  vmcpow (const int *n, const MKL_Complex8 a[], const MKL_Complex8 b[], MKL_Complex8 r[], long long int *mode);
extern void  vmzpow (const int *n, const MKL_Complex16 a[], const MKL_Complex16 b[], MKL_Complex16 r[], long long int *mode);
extern void  vmcPow (const int n, const MKL_Complex8 a[], const MKL_Complex8 b[], MKL_Complex8 r[], long long int mode);
extern void  vmzPow (const int n, const MKL_Complex16 a[], const MKL_Complex16 b[], MKL_Complex16 r[], long long int mode);


extern void  VSPOW3O2 (const int *n, const float a[], float r[]);
extern void  VDPOW3O2 (const int *n, const double a[], double r[]);
extern void  vspow3o2 (const int *n, const float a[], float r[]);
extern void  vdpow3o2 (const int *n, const double a[], double r[]);
extern void  vsPow3o2 (const int n, const float a[], float r[]);
extern void  vdPow3o2 (const int n, const double a[], double r[]);

extern void  VMSPOW3O2 (const int *n, const float a[], float r[], long long int *mode);
extern void  VMDPOW3O2 (const int *n, const double a[], double r[], long long int *mode);
extern void  vmspow3o2 (const int *n, const float a[], float r[], long long int *mode);
extern void  vmdpow3o2 (const int *n, const double a[], double r[], long long int *mode);
extern void  vmsPow3o2 (const int n, const float a[], float r[], long long int mode);
extern void  vmdPow3o2 (const int n, const double a[], double r[], long long int mode);


extern void  VSPOW2O3 (const int *n, const float a[], float r[]);
extern void  VDPOW2O3 (const int *n, const double a[], double r[]);
extern void  vspow2o3 (const int *n, const float a[], float r[]);
extern void  vdpow2o3 (const int *n, const double a[], double r[]);
extern void  vsPow2o3 (const int n, const float a[], float r[]);
extern void  vdPow2o3 (const int n, const double a[], double r[]);

extern void  VMSPOW2O3 (const int *n, const float a[], float r[], long long int *mode);
extern void  VMDPOW2O3 (const int *n, const double a[], double r[], long long int *mode);
extern void  vmspow2o3 (const int *n, const float a[], float r[], long long int *mode);
extern void  vmdpow2o3 (const int *n, const double a[], double r[], long long int *mode);
extern void  vmsPow2o3 (const int n, const float a[], float r[], long long int mode);
extern void  vmdPow2o3 (const int n, const double a[], double r[], long long int mode);


extern void  VSPOWX (const int *n, const float a[], const float *b, float r[]);
extern void  VDPOWX (const int *n, const double a[], const double *b, double r[]);
extern void  vspowx (const int *n, const float a[], const float *b, float r[]);
extern void  vdpowx (const int *n, const double a[], const double *b, double r[]);
extern void  vsPowx (const int n, const float a[], const float b, float r[]);
extern void  vdPowx (const int n, const double a[], const double b, double r[]);

extern void  VMSPOWX (const int *n, const float a[], const float *b, float r[], long long int *mode);
extern void  VMDPOWX (const int *n, const double a[], const double *b, double r[], long long int *mode);
extern void  vmspowx (const int *n, const float a[], const float *b, float r[], long long int *mode);
extern void  vmdpowx (const int *n, const double a[], const double *b, double r[], long long int *mode);
extern void  vmsPowx (const int n, const float a[], const float b, float r[], long long int mode);
extern void  vmdPowx (const int n, const double a[], const double b, double r[], long long int mode);


extern void  VCPOWX (const int *n, const MKL_Complex8 a[], const MKL_Complex8 *b, MKL_Complex8 r[]);
extern void  VZPOWX (const int *n, const MKL_Complex16 a[], const MKL_Complex16 *b, MKL_Complex16 r[]);
extern void  vcpowx (const int *n, const MKL_Complex8 a[], const MKL_Complex8 *b, MKL_Complex8 r[]);
extern void  vzpowx (const int *n, const MKL_Complex16 a[], const MKL_Complex16 *b, MKL_Complex16 r[]);
extern void  vcPowx (const int n, const MKL_Complex8 a[], const MKL_Complex8 b, MKL_Complex8 r[]);
extern void  vzPowx (const int n, const MKL_Complex16 a[], const MKL_Complex16 b, MKL_Complex16 r[]);

extern void  VMCPOWX (const int *n, const MKL_Complex8 a[], const MKL_Complex8 *b, MKL_Complex8 r[], long long int *mode);
extern void  VMZPOWX (const int *n, const MKL_Complex16 a[], const MKL_Complex16 *b, MKL_Complex16 r[], long long int *mode);
extern void  vmcpowx (const int *n, const MKL_Complex8 a[], const MKL_Complex8 *b, MKL_Complex8 r[], long long int *mode);
extern void  vmzpowx (const int *n, const MKL_Complex16 a[], const MKL_Complex16 *b, MKL_Complex16 r[], long long int *mode);
extern void  vmcPowx (const int n, const MKL_Complex8 a[], const MKL_Complex8 b, MKL_Complex8 r[], long long int mode);
extern void  vmzPowx (const int n, const MKL_Complex16 a[], const MKL_Complex16 b, MKL_Complex16 r[], long long int mode);


extern void  VSSINCOS (const int *n, const float a[], float r1[], float r2[]);
extern void  VDSINCOS (const int *n, const double a[], double r1[], double r2[]);
extern void  vssincos (const int *n, const float a[], float r1[], float r2[]);
extern void  vdsincos (const int *n, const double a[], double r1[], double r2[]);
extern void  vsSinCos (const int n, const float a[], float r1[], float r2[]);
extern void  vdSinCos (const int n, const double a[], double r1[], double r2[]);

extern void  VMSSINCOS (const int *n, const float a[], float r1[], float r2[], long long int *mode);
extern void  VMDSINCOS (const int *n, const double a[], double r1[], double r2[], long long int *mode);
extern void  vmssincos (const int *n, const float a[], float r1[], float r2[], long long int *mode);
extern void  vmdsincos (const int *n, const double a[], double r1[], double r2[], long long int *mode);
extern void  vmsSinCos (const int n, const float a[], float r1[], float r2[], long long int mode);
extern void  vmdSinCos (const int n, const double a[], double r1[], double r2[], long long int mode);


extern void  VSLINEARFRAC (const int *n, const float a[], const float b[], const float *scalea, const float *shifta, const float *scaleb, const float *shiftb, float r[]);
extern void  VDLINEARFRAC (const int *n, const double a[], const double b[], const double *scalea, const double *shifta, const double *scaleb, const double *shiftb, double r[]);
extern void  vslinearfrac (const int *n, const float a[], const float b[], const float *scalea, const float *shifta, const float *scaleb, const float *shiftb, float r[]);
extern void  vdlinearfrac (const int *n, const double a[], const double b[], const double *scalea, const double *shifta, const double *scaleb, const double *shiftb, double r[]);
extern void  vsLinearFrac (const int n, const float a[], const float b[], const float scalea, const float shifta, const float scaleb, const float shiftb, float r[]);
extern void  vdLinearFrac (const int n, const double a[], const double b[], const double scalea, const double shifta, const double scaleb, const double shiftb, double r[]);

extern void  VMSLINEARFRAC (const int *n, const float a[], const float b[], const float *scalea, const float *shifta, const float *scaleb, const float *shiftb, float r[], long long int *mode);
extern void  VMDLINEARFRAC (const int *n, const double a[], const double b[], const double *scalea, const double *shifta, const double *scaleb, const double *shiftb, double r[], long long int *mode);
extern void  vmslinearfrac (const int *n, const float a[], const float b[], const float *scalea, const float *shifta, const float *scaleb, const float *shiftb, float r[], long long int *mode);
extern void  vmdlinearfrac (const int *n, const double a[], const double b[], const double *scalea, const double *shifta, const double *scaleb, const double *shiftb, double r[], long long int *mode);
extern void  vmsLinearFrac (const int n, const float a[], const float b[], const float scalea, const float shifta, const float scaleb, const float shiftb, float r[], long long int mode);
extern void  vmdLinearFrac (const int n, const double a[], const double b[], const double scalea, const double shifta, const double scaleb, const double shiftb, double r[], long long int mode);


extern void  VSCEIL (const int *n, const float a[], float r[]);
extern void  VDCEIL (const int *n, const double a[], double r[]);
extern void  vsceil (const int *n, const float a[], float r[]);
extern void  vdceil (const int *n, const double a[], double r[]);
extern void  vsCeil (const int n, const float a[], float r[]);
extern void  vdCeil (const int n, const double a[], double r[]);

extern void  VMSCEIL (const int *n, const float a[], float r[], long long int *mode);
extern void  VMDCEIL (const int *n, const double a[], double r[], long long int *mode);
extern void  vmsceil (const int *n, const float a[], float r[], long long int *mode);
extern void  vmdceil (const int *n, const double a[], double r[], long long int *mode);
extern void  vmsCeil (const int n, const float a[], float r[], long long int mode);
extern void  vmdCeil (const int n, const double a[], double r[], long long int mode);


extern void  VSFLOOR (const int *n, const float a[], float r[]);
extern void  VDFLOOR (const int *n, const double a[], double r[]);
extern void  vsfloor (const int *n, const float a[], float r[]);
extern void  vdfloor (const int *n, const double a[], double r[]);
extern void  vsFloor (const int n, const float a[], float r[]);
extern void  vdFloor (const int n, const double a[], double r[]);

extern void  VMSFLOOR (const int *n, const float a[], float r[], long long int *mode);
extern void  VMDFLOOR (const int *n, const double a[], double r[], long long int *mode);
extern void  vmsfloor (const int *n, const float a[], float r[], long long int *mode);
extern void  vmdfloor (const int *n, const double a[], double r[], long long int *mode);
extern void  vmsFloor (const int n, const float a[], float r[], long long int mode);
extern void  vmdFloor (const int n, const double a[], double r[], long long int mode);


extern void  VSFRAC (const int *n, const float a[], float r[]);
extern void  VDFRAC (const int *n, const double a[], double r[]);
extern void  vsfrac (const int *n, const float a[], float r[]);
extern void  vdfrac (const int *n, const double a[], double r[]);
extern void  vsFrac (const int n, const float a[], float r[]);
extern void  vdFrac (const int n, const double a[], double r[]);

extern void  VMSFRAC (const int *n, const float a[], float r[], long long int *mode);
extern void  VMDFRAC (const int *n, const double a[], double r[], long long int *mode);
extern void  vmsfrac (const int *n, const float a[], float r[], long long int *mode);
extern void  vmdfrac (const int *n, const double a[], double r[], long long int *mode);
extern void  vmsFrac (const int n, const float a[], float r[], long long int mode);
extern void  vmdFrac (const int n, const double a[], double r[], long long int mode);


extern void  VSMODF (const int *n, const float a[], float r1[], float r2[]);
extern void  VDMODF (const int *n, const double a[], double r1[], double r2[]);
extern void  vsmodf (const int *n, const float a[], float r1[], float r2[]);
extern void  vdmodf (const int *n, const double a[], double r1[], double r2[]);
extern void  vsModf (const int n, const float a[], float r1[], float r2[]);
extern void  vdModf (const int n, const double a[], double r1[], double r2[]);

extern void  VMSMODF (const int *n, const float a[], float r1[], float r2[], long long int *mode);
extern void  VMDMODF (const int *n, const double a[], double r1[], double r2[], long long int *mode);
extern void  vmsmodf (const int *n, const float a[], float r1[], float r2[], long long int *mode);
extern void  vmdmodf (const int *n, const double a[], double r1[], double r2[], long long int *mode);
extern void  vmsModf (const int n, const float a[], float r1[], float r2[], long long int mode);
extern void  vmdModf (const int n, const double a[], double r1[], double r2[], long long int mode);


extern void  VSNEARBYINT (const int *n, const float a[], float r[]);
extern void  VDNEARBYINT (const int *n, const double a[], double r[]);
extern void  vsnearbyint (const int *n, const float a[], float r[]);
extern void  vdnearbyint (const int *n, const double a[], double r[]);
extern void  vsNearbyInt (const int n, const float a[], float r[]);
extern void  vdNearbyInt (const int n, const double a[], double r[]);

extern void  VMSNEARBYINT (const int *n, const float a[], float r[], long long int *mode);
extern void  VMDNEARBYINT (const int *n, const double a[], double r[], long long int *mode);
extern void  vmsnearbyint (const int *n, const float a[], float r[], long long int *mode);
extern void  vmdnearbyint (const int *n, const double a[], double r[], long long int *mode);
extern void  vmsNearbyInt (const int n, const float a[], float r[], long long int mode);
extern void  vmdNearbyInt (const int n, const double a[], double r[], long long int mode);


extern void  VSRINT (const int *n, const float a[], float r[]);
extern void  VDRINT (const int *n, const double a[], double r[]);
extern void  vsrint (const int *n, const float a[], float r[]);
extern void  vdrint (const int *n, const double a[], double r[]);
extern void  vsRint (const int n, const float a[], float r[]);
extern void  vdRint (const int n, const double a[], double r[]);

extern void  VMSRINT (const int *n, const float a[], float r[], long long int *mode);
extern void  VMDRINT (const int *n, const double a[], double r[], long long int *mode);
extern void  vmsrint (const int *n, const float a[], float r[], long long int *mode);
extern void  vmdrint (const int *n, const double a[], double r[], long long int *mode);
extern void  vmsRint (const int n, const float a[], float r[], long long int mode);
extern void  vmdRint (const int n, const double a[], double r[], long long int mode);


extern void  VSROUND (const int *n, const float a[], float r[]);
extern void  VDROUND (const int *n, const double a[], double r[]);
extern void  vsround (const int *n, const float a[], float r[]);
extern void  vdround (const int *n, const double a[], double r[]);
extern void  vsRound (const int n, const float a[], float r[]);
extern void  vdRound (const int n, const double a[], double r[]);

extern void  VMSROUND (const int *n, const float a[], float r[], long long int *mode);
extern void  VMDROUND (const int *n, const double a[], double r[], long long int *mode);
extern void  vmsround (const int *n, const float a[], float r[], long long int *mode);
extern void  vmdround (const int *n, const double a[], double r[], long long int *mode);
extern void  vmsRound (const int n, const float a[], float r[], long long int mode);
extern void  vmdRound (const int n, const double a[], double r[], long long int mode);


extern void  VSTRUNC (const int *n, const float a[], float r[]);
extern void  VDTRUNC (const int *n, const double a[], double r[]);
extern void  vstrunc (const int *n, const float a[], float r[]);
extern void  vdtrunc (const int *n, const double a[], double r[]);
extern void  vsTrunc (const int n, const float a[], float r[]);
extern void  vdTrunc (const int n, const double a[], double r[]);

extern void  VMSTRUNC (const int *n, const float a[], float r[], long long int *mode);
extern void  VMDTRUNC (const int *n, const double a[], double r[], long long int *mode);
extern void  vmstrunc (const int *n, const float a[], float r[], long long int *mode);
extern void  vmdtrunc (const int *n, const double a[], double r[], long long int *mode);
extern void  vmsTrunc (const int n, const float a[], float r[], long long int mode);
extern void  vmdTrunc (const int n, const double a[], double r[], long long int mode);


extern void  VCCONJ (const int *n, const MKL_Complex8 a[], MKL_Complex8 r[]);
extern void  VZCONJ (const int *n, const MKL_Complex16 a[], MKL_Complex16 r[]);
extern void  vcconj (const int *n, const MKL_Complex8 a[], MKL_Complex8 r[]);
extern void  vzconj (const int *n, const MKL_Complex16 a[], MKL_Complex16 r[]);
extern void  vcConj (const int n, const MKL_Complex8 a[], MKL_Complex8 r[]);
extern void  vzConj (const int n, const MKL_Complex16 a[], MKL_Complex16 r[]);

extern void  VMCCONJ (const int *n, const MKL_Complex8 a[], MKL_Complex8 r[], long long int *mode);
extern void  VMZCONJ (const int *n, const MKL_Complex16 a[], MKL_Complex16 r[], long long int *mode);
extern void  vmcconj (const int *n, const MKL_Complex8 a[], MKL_Complex8 r[], long long int *mode);
extern void  vmzconj (const int *n, const MKL_Complex16 a[], MKL_Complex16 r[], long long int *mode);
extern void  vmcConj (const int n, const MKL_Complex8 a[], MKL_Complex8 r[], long long int mode);
extern void  vmzConj (const int n, const MKL_Complex16 a[], MKL_Complex16 r[], long long int mode);


extern void  VCMULBYCONJ (const int *n, const MKL_Complex8 a[], const MKL_Complex8 b[], MKL_Complex8 r[]);
extern void  VZMULBYCONJ (const int *n, const MKL_Complex16 a[], const MKL_Complex16 b[], MKL_Complex16 r[]);
extern void  vcmulbyconj (const int *n, const MKL_Complex8 a[], const MKL_Complex8 b[], MKL_Complex8 r[]);
extern void  vzmulbyconj (const int *n, const MKL_Complex16 a[], const MKL_Complex16 b[], MKL_Complex16 r[]);
extern void  vcMulByConj (const int n, const MKL_Complex8 a[], const MKL_Complex8 b[], MKL_Complex8 r[]);
extern void  vzMulByConj (const int n, const MKL_Complex16 a[], const MKL_Complex16 b[], MKL_Complex16 r[]);

extern void  VMCMULBYCONJ (const int *n, const MKL_Complex8 a[], const MKL_Complex8 b[], MKL_Complex8 r[], long long int *mode);
extern void  VMZMULBYCONJ (const int *n, const MKL_Complex16 a[], const MKL_Complex16 b[], MKL_Complex16 r[], long long int *mode);
extern void  vmcmulbyconj (const int *n, const MKL_Complex8 a[], const MKL_Complex8 b[], MKL_Complex8 r[], long long int *mode);
extern void  vmzmulbyconj (const int *n, const MKL_Complex16 a[], const MKL_Complex16 b[], MKL_Complex16 r[], long long int *mode);
extern void  vmcMulByConj (const int n, const MKL_Complex8 a[], const MKL_Complex8 b[], MKL_Complex8 r[], long long int mode);
extern void  vmzMulByConj (const int n, const MKL_Complex16 a[], const MKL_Complex16 b[], MKL_Complex16 r[], long long int mode);


extern void  VCCIS (const int *n, const float a[], MKL_Complex8 r[]);
extern void  VZCIS (const int *n, const double a[], MKL_Complex16 r[]);
extern void  vccis (const int *n, const float a[], MKL_Complex8 r[]);
extern void  vzcis (const int *n, const double a[], MKL_Complex16 r[]);
extern void  vcCIS (const int n, const float a[], MKL_Complex8 r[]);
extern void  vzCIS (const int n, const double a[], MKL_Complex16 r[]);

extern void  VMCCIS (const int *n, const float a[], MKL_Complex8 r[], long long int *mode);
extern void  VMZCIS (const int *n, const double a[], MKL_Complex16 r[], long long int *mode);
extern void  vmccis (const int *n, const float a[], MKL_Complex8 r[], long long int *mode);
extern void  vmzcis (const int *n, const double a[], MKL_Complex16 r[], long long int *mode);
extern void  vmcCIS (const int n, const float a[], MKL_Complex8 r[], long long int mode);
extern void  vmzCIS (const int n, const double a[], MKL_Complex16 r[], long long int mode);







extern void  VSPACKI (const int *n, const float a[], const int * incra, float y[]);
extern void  VDPACKI (const int *n, const double a[], const int * incra, double y[]);
extern void  vspacki (const int *n, const float a[], const int * incra, float y[]);
extern void  vdpacki (const int *n, const double a[], const int * incra, double y[]);
extern void  vsPackI (const int n, const float a[], const int incra, float y[]);
extern void  vdPackI (const int n, const double a[], const int incra, double y[]);

extern void  VCPACKI (const int *n, const MKL_Complex8 a[], const int * incra, MKL_Complex8 y[]);
extern void  VZPACKI (const int *n, const MKL_Complex16 a[], const int * incra, MKL_Complex16 y[]);
extern void  vcpacki (const int *n, const MKL_Complex8 a[], const int * incra, MKL_Complex8 y[]);
extern void  vzpacki (const int *n, const MKL_Complex16 a[], const int * incra, MKL_Complex16 y[]);
extern void  vcPackI (const int n, const MKL_Complex8 a[], const int incra, MKL_Complex8 y[]);
extern void  vzPackI (const int n, const MKL_Complex16 a[], const int incra, MKL_Complex16 y[]);


extern void  VSPACKV (const int *n, const float a[], const int ia[], float y[]);
extern void  VDPACKV (const int *n, const double a[], const int ia[], double y[]);
extern void  vspackv (const int *n, const float a[], const int ia[], float y[]);
extern void  vdpackv (const int *n, const double a[], const int ia[], double y[]);
extern void  vsPackV (const int n, const float a[], const int ia[], float y[]);
extern void  vdPackV (const int n, const double a[], const int ia[], double y[]);

extern void  VCPACKV (const int *n, const MKL_Complex8 a[], const int ia[], MKL_Complex8 y[]);
extern void  VZPACKV (const int *n, const MKL_Complex16 a[], const int ia[], MKL_Complex16 y[]);
extern void  vcpackv (const int *n, const MKL_Complex8 a[], const int ia[], MKL_Complex8 y[]);
extern void  vzpackv (const int *n, const MKL_Complex16 a[], const int ia[], MKL_Complex16 y[]);
extern void  vcPackV (const int n, const MKL_Complex8 a[], const int ia[], MKL_Complex8 y[]);
extern void  vzPackV (const int n, const MKL_Complex16 a[], const int ia[], MKL_Complex16 y[]);


extern void  VSPACKM (const int *n, const float a[], const int ma[], float y[]);
extern void  VDPACKM (const int *n, const double a[], const int ma[], double y[]);
extern void  vspackm (const int *n, const float a[], const int ma[], float y[]);
extern void  vdpackm (const int *n, const double a[], const int ma[], double y[]);
extern void  vsPackM (const int n, const float a[], const int ma[], float y[]);
extern void  vdPackM (const int n, const double a[], const int ma[], double y[]);

extern void  VCPACKM (const int *n, const MKL_Complex8 a[], const int ma[], MKL_Complex8 y[]);
extern void  VZPACKM (const int *n, const MKL_Complex16 a[], const int ma[], MKL_Complex16 y[]);
extern void  vcpackm (const int *n, const MKL_Complex8 a[], const int ma[], MKL_Complex8 y[]);
extern void  vzpackm (const int *n, const MKL_Complex16 a[], const int ma[], MKL_Complex16 y[]);
extern void  vcPackM (const int n, const MKL_Complex8 a[], const int ma[], MKL_Complex8 y[]);
extern void  vzPackM (const int n, const MKL_Complex16 a[], const int ma[], MKL_Complex16 y[]);







extern void  VSUNPACKI (const int *n, const float a[], float y[], const int * incry);
extern void  VDUNPACKI (const int *n, const double a[], double y[], const int * incry);
extern void  vsunpacki (const int *n, const float a[], float y[], const int * incry);
extern void  vdunpacki (const int *n, const double a[], double y[], const int * incry);
extern void  vsUnpackI (const int n, const float a[], float y[], const int incry );
extern void  vdUnpackI (const int n, const double a[], double y[], const int incry );

extern void  VCUNPACKI (const int *n, const MKL_Complex8 a[], MKL_Complex8 y[], const int * incry);
extern void  VZUNPACKI (const int *n, const MKL_Complex16 a[], MKL_Complex16 y[], const int * incry);
extern void  vcunpacki (const int *n, const MKL_Complex8 a[], MKL_Complex8 y[], const int * incry);
extern void  vzunpacki (const int *n, const MKL_Complex16 a[], MKL_Complex16 y[], const int * incry);
extern void  vcUnpackI (const int n, const MKL_Complex8 a[], MKL_Complex8 y[], const int incry );
extern void  vzUnpackI (const int n, const MKL_Complex16 a[], MKL_Complex16 y[], const int incry );


extern void  VSUNPACKV (const int *n, const float a[], float y[], const int iy[] );
extern void  VDUNPACKV (const int *n, const double a[], double y[], const int iy[] );
extern void  vsunpackv (const int *n, const float a[], float y[], const int iy[] );
extern void  vdunpackv (const int *n, const double a[], double y[], const int iy[] );
extern void  vsUnpackV (const int n, const float a[], float y[], const int iy[] );
extern void  vdUnpackV (const int n, const double a[], double y[], const int iy[] );

extern void  VCUNPACKV (const int *n, const MKL_Complex8 a[], MKL_Complex8 y[], const int iy[]);
extern void  VZUNPACKV (const int *n, const MKL_Complex16 a[], MKL_Complex16 y[], const int iy[]);
extern void  vcunpackv (const int *n, const MKL_Complex8 a[], MKL_Complex8 y[], const int iy[]);
extern void  vzunpackv (const int *n, const MKL_Complex16 a[], MKL_Complex16 y[], const int iy[]);
extern void  vcUnpackV (const int n, const MKL_Complex8 a[], MKL_Complex8 y[], const int iy[]);
extern void  vzUnpackV (const int n, const MKL_Complex16 a[], MKL_Complex16 y[], const int iy[]);


extern void  VSUNPACKM (const int *n, const float a[], float y[], const int my[] );
extern void  VDUNPACKM (const int *n, const double a[], double y[], const int my[] );
extern void  vsunpackm (const int *n, const float a[], float y[], const int my[] );
extern void  vdunpackm (const int *n, const double a[], double y[], const int my[] );
extern void  vsUnpackM (const int n, const float a[], float y[], const int my[] );
extern void  vdUnpackM (const int n, const double a[], double y[], const int my[] );

extern void  VCUNPACKM (const int *n, const MKL_Complex8 a[], MKL_Complex8 y[], const int my[]);
extern void  VZUNPACKM (const int *n, const MKL_Complex16 a[], MKL_Complex16 y[], const int my[]);
extern void  vcunpackm (const int *n, const MKL_Complex8 a[], MKL_Complex8 y[], const int my[]);
extern void  vzunpackm (const int *n, const MKL_Complex16 a[], MKL_Complex16 y[], const int my[]);
extern void  vcUnpackM (const int n, const MKL_Complex8 a[], MKL_Complex8 y[], const int my[]);
extern void  vzUnpackM (const int n, const MKL_Complex16 a[], MKL_Complex16 y[], const int my[]);








extern int  VMLSETERRSTATUS (const int * status);
extern int  vmlseterrstatus (const int * status);
extern int  vmlSetErrStatus (const int status);


extern int  VMLGETERRSTATUS (void);
extern int  vmlgeterrstatus (void);
extern int  vmlGetErrStatus (void);


extern int  VMLCLEARERRSTATUS (void);
extern int  vmlclearerrstatus (void);
extern int  vmlClearErrStatus (void);


extern VMLErrorCallBack  VMLSETERRORCALLBACK (const VMLErrorCallBack func);
extern VMLErrorCallBack  vmlseterrorcallback (const VMLErrorCallBack func);
extern VMLErrorCallBack  vmlSetErrorCallBack (const VMLErrorCallBack func);


extern VMLErrorCallBack  VMLGETERRORCALLBACK (void);
extern VMLErrorCallBack  vmlgeterrorcallback (void);
extern VMLErrorCallBack  vmlGetErrorCallBack (void);


extern VMLErrorCallBack  VMLCLEARERRORCALLBACK (void);
extern VMLErrorCallBack  vmlclearerrorcallback (void);
extern VMLErrorCallBack  vmlClearErrorCallBack (void);








extern unsigned int  VMLSETMODE (const unsigned int *newmode);
extern unsigned int  vmlsetmode (const unsigned int *newmode);
extern unsigned int  vmlSetMode (const unsigned int newmode);


extern unsigned int  VMLGETMODE (void);
extern unsigned int  vmlgetmode (void);
extern unsigned int  vmlGetMode (void);









